#include <windows.h>
#include <winnt.h>
#include <stdio.h>

IMAGE_NT_HEADERS *(__stdcall * _CheckSumMappedFile)(void*,DWORD,DWORD*,DWORD*) = 0;

void process(char *filename, unsigned const *tab)
{
   printf("processing %s... ", filename);
   FILE *ff = fopen(filename, "rb");
   if (!ff) { printf("file not found\n"); return; }
   fseek(ff, 0, SEEK_END);
   unsigned size = ftell(ff); rewind(ff);

   BYTE *data = (BYTE*)malloc(size);
   if (!data) { printf("out of memory!"); exit(2); }

   fread(data, 1, size, ff);
   fclose(ff);

   for (int done = 0; *tab; tab++) {
      if (*tab >= size || data[*tab-1] != 0x0F || (data[*tab]|8) != 0xBE)
      { printf("wrong file version\n"); free(data); return; }
      if (data[*tab] == 0xBE) done++, data[*tab] = 0xB6;
   }

   if (done) {
      ff = fopen(filename, "wb");
      if (ff) {
         if (_CheckSumMappedFile) {
            DWORD csum, oldsum;
            IMAGE_NT_HEADERS *nt_header = _CheckSumMappedFile(data, size, &oldsum, &csum);
            if (nt_header) nt_header->OptionalHeader.CheckSum = csum;
         }
         fwrite(data, 1, size, ff);
         fclose(ff); printf("bug fixed\n");
      } else printf("file write error\n");
   } else printf("bug#16 already fixed\n");

   free(data);
}


void __cdecl main()
{
   printf("bugfix for UnrealSpeccy 0.21b5 bug#16 by SMT\n\n");

   HMODULE dll = LoadLibrary("imagehlp.dll");
   if (dll) _CheckSumMappedFile =
      (IMAGE_NT_HEADERS *(__stdcall *)(void*,DWORD,DWORD*,DWORD*))
        GetProcAddress(dll, "CheckSumMappedFile");

   static const unsigned p6_tab[] = { 0x29EAE, 0x29ED1, 0x29ED8, 0 };
   static const unsigned p5_tab[] = { 0x2997F, 0x299A4, 0x299B0, 0 };
   static const unsigned lt_tab[] = { 0x2A56C, 0x2A58F, 0x2A596, 0 };

   process("unreal_p6.exe", p6_tab);
   process("unreal_p5.exe", p5_tab);
   process("unrelite.exe", lt_tab);

   if (dll) FreeLibrary(dll);
}

#pragma comment(lib,"kernel32")
#pragma comment(linker,"/entry:main")
